/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... jednorozmerne staticke pole II
*/
#include <iostream>
#include <ctime>
using namespace std;

/* Vypis vsech prvku pole a delky n na konzoli. */
void vypis(const double *a, int n)
{
	for (int i = 0; i < n; i++)
		cout << a[i] << " ";
	cout << endl;
}

/* Funkce vrati skalarni soucin vektoru x a y delky n. */
double skalarni_soucin(const double *x, const double *y, int n)
{
	double skalar = 0;
	for (int i = 0; i < n; i++)
		skalar += x[i] * y[i];
	return skalar;
}

/* Funkce vrati true, pokud jsou vektory x a y delky n kolme. */
bool kolme(const double *x, const double *y, int n)
{/*
	if (skalarni(x, y, n) == 0)
		return true;
	else
		return false;
 */
	return (skalarni_soucin(x, y, n) == 0);
}

/* Funkce prohodi v poli a prvky na indexech i a j. */
void prohod(double *a, int i, int j)
{
	double pom = a[i];
	a[i] = a[j];
	a[j] = pom;
}

/* Funkce otoci pole a delky n. */
void otoc0(double a[], int n)
{
	int i = 0, j = n - 1;
	while (i < j)
	{
		prohod(a, i, j);
		i++;
		j--;
	}
}

/* Funkce otoci pole a delky n. */
void otoc(double a[], int n)
{
	int i, j;
	for (i = 0, j = n - 1; i < j; i++, j--)
		prohod(a, i, j);
}

/* Funkce vrati index minima pole v poli "a" mezi indexy od a po (vcetne) */
int index_minima(const double *a, int od, int po)
{
	int imin = od;
	for (int j = od + 1; j <= po; j++)
	{
		if (a[j] < a[imin])
		{
			imin = j;
		}
	}
	return imin;
}

/* Funkce setridi pole a delky n metodou trideni vyberem. */
void setrid_vyberem(double a[], int delka)
{
	int i, imin;
	for (i = 0; i < delka - 1; i++)
	{
		imin = index_minima(a, i, delka - 1);
		prohod(a, i, imin);
	}
}

/* Funkce setridi pole a delky n metodou bublinkoveho trideni. */
void setrid_bublinky0(double a[], int delka)
{
	for (int i = 1; i < delka; i++)
	{
		for (int j = delka - 1; j > 0; j--)
		{
			if (a[j - 1] > a[j])
				prohod(a, j, j - 1);
		}
	}
}

/* Funkce setridi pole a delky n metodou bublinkoveho trideni. */
void setrid_bublinky(double a[], int delka)
{
	for (int i = 1; i < delka; i++)
	{
		for (int j = delka - 1; j >= i; j--)
		{
			if (a[j - 1] > a[j])
				prohod(a, j, j - 1);
		}
	}
}

int main()
{
	double x[] = { 0,-1,0,1 }, y[] = {1,2.4,1,2.4};
	cout << "Skalarni soucin vektoru je " << skalarni_soucin(x, y, 4) << endl;
	if (kolme(x, y, 4))
		cout << "Vektory jsou kolme.\n";

	double a[10] = { 7,2,7,-4.1, 7.8, 8, 9.8, -5.8, 2 };
	double b[10] = { 10,9,8,7,6,5,4,3,2,1 };
	otoc(a, 9);
	vypis(a, 10);
	// setrid_vyberem(a,10);
	setrid_bublinky(a,10);
	vypis(a, 10);
	return 0;
}
