/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... typedef, enum
*/

#include<iostream>
#include<string>

using namespace std;

const int n = 10;
typedef int cislo;
typedef cislo male_pole[10];
typedef unsigned int UInt;
typedef const UInt CUInt;

cislo minimum(cislo a, cislo b)
{
	return (a < b) ? a : b;
}

double funkce(double x, double a, double b)
{
	return (x < a) ? a : (x > b) ? b : x;
}

void test_typedef()
{
	// typedef
	int a = 7;
	cislo b = 8, c = 6;
	b = a;
	a = minimum(b, c);
	male_pole p = { 1,2 };
	CUInt moje = 9;
	a = p[1];

	// podmineny vyraz
	double x, y, m;
	cin >> x >> y;
	x = (x >= 0) ? x : -x; // absolutni hodnota
	m = (x > y) ? x : y;  // maximum dvou cisel
	cout << funkce(x, 0, 1) << funkce(0.5, 0, 1) << funkce(-4, 0, 1);
}

//////////////////////////////////////////////////////////////////////

enum Vsedni_den { po, ut, st, ct = 8, pa } dnes, zitra;
enum Svetova_strana { sever = 1, jih = 2, vychod = 4, zapad = 8 };

enum Den { pondeli, utery, streda, ctvrtek, patek, sobota, nedele };

//Svetova_strana dovolenySmer = (Svetova_strana)(sever | jih);
const int dovoleny_smer = (sever | jih);

void vypis_den(Den den)
{
	/*
	cout << "Dnes je " << den;
	switch (den)
	{
	case pondeli:
		cout << "pondeli";
		break;
	case utery:
		cout << "utery";
		break;
		//...
	}
	*/
	const static string jmena[] = { "pondeli","utery","streda","ctvrtek","patek","sobota","nedele" };
	if (den < 7 && den >= 0)
		cout << "Dnes je " << jmena[den] << endl;
}

bool vikend(Den den)
{
	return (den > patek);
	// return (den == sobota || den == nedele);
}

bool povoleny_smer(Svetova_strana tam)
{
	//cout << dovoleny_smer << endl;
	/*
	if ((int)tam & dovoleny_smer)
	{
		return true;
		//cout << "Muzes";
	}
	else
	{
		return false;
		// cout << "Nemuzes";
	}
	// cout << endl;
	*/
	return ((int)tam & dovoleny_smer);
}

int main()
{

	Den dnes = utery;
	cout << dnes << endl;
	Den zitra = (Den)(dnes + 1);
	if (dnes == ctvrtek)
		cout << "Dnes je ctvrtek" << endl;
	else
		cout << "Dnes neni ctvrtek" << endl;

	dnes = (Den)5;
	vypis_den(nedele);
	vypis_den(dnes);
	vypis_den(zitra);
	// budou mimo meze
	vypis_den((Den)-5);

	cout << vikend(sobota) << vikend(patek) << endl;

	cout << povoleny_smer(jih) << povoleny_smer(vychod) << povoleny_smer((Svetova_strana)zitra) << endl;

	return 0;
}